#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#define FALSE 0
#define TRUE 1
#define NUM 3

int Okay; /* Boolean */

main(void)
{
   /*
   **   Listing10.1.c - Recovery from the termination of a subtask
   */
   void sig_child();
   int pids[NUM];
   int ii, jj;
   int pid;

   /* setup SIGCHLD handler */
   signal(SIGCHLD, sig_child);

   /*
   **   Start NUM subtasks
   */
   for(ii=0; ii<NUM; ii++) {
      if((pids[ii]=fork()) == 0) {
         printf("\tSubtask #%d started, pid = %d\n", ii, getpid());
         while(1)
            usleep(1);
      }
   }

   /*
   **   Wait for a subtask to end
   */
   while(1) {
      Okay = TRUE;
      while(Okay) /* pause */
         usleep(1);

      pid = wait(NULL); /* exiting pid */
      for(ii=0; ii<NUM; ii++)
         if(pid == pids[ii])
            break;
      printf("\tSubtask #%d ended, pid = %d\n", ii, pids[ii]);
      if((pids[ii]=fork()) == 0) {
         printf("\tSubtask #%d restarted, pid = %d\n", ii, getpid());
         while(1)
            usleep(1);
      }
   }
}
void sig_child() {
   signal(SIGCHLD, sig_child);
   Okay = FALSE;
   return;
}
